  /*
   *  Object %name    : parser_atp_sst_mm.c%
   *  State           :  %state%
   *  Creation date   :  Apr 13 2009
   *  Last modified   :  %modify_time%
   */
  /** @file
   *  \brief This file includes the DH parsing functions  
   *
   *  \version parser_atp_sst_mm.c#1:csrc:1
   *  \author  taniam
   *  \remarks Copyright (C) 2004 by Discretix Technologies Ltd.
   *           All Rights reserved
   */
/************* Include Files ****************/
#include "SST_SEP_ATP_MM.h"
#include "parser_atp_sst_mm.h"
#include "SST_SEP_TST.h"
#include "sep_utils.h"
/************************ Global Data ************************/
    extern DxByte_t*                               TST_Workspace;
    extern DxUint32_t                              TST_WorkspaceSizeInBytes ;
    extern DxUint8_t*                              GlobalMemBuff;
    extern DxUint8_t*                              CurrGlobalMemBuff;
    TST_ATP_MMDataOpTestDataStruct*                 TST_ATP_MMDataOpTestData;

/*****************************************************************************
* Function Name:
*  DX_SEP_PARSER_SST_MM_1
*  
* Inputs:
*  msg - message with all requested parameters.
*
* Outputs: 
*  DxUint32_t - Function error return
*
* Description:
* This function does the parsing for the external application SEPQA_SST_Iterator finction.
* It calls the SEP function with parameters parsed from input message
*
* Algorithm: 
* 1. call to DX_SEP_MNG_SSTGetWorkspaceParams
* 2. allocate memory for GlobalMemBuff for all next needed allocation in the test
* 3. allocate buffer from GlobalMemBuff to data struct
* 4. extract parameters from the message 
* 5. call QA SEP function
* 6. free allocated GlobalMemBuff
* 7. update SEP message with appropriate  op code and updated data struct
* 8. end SEP message and return
******************************************************************************/ 
DxUint32_t DX_SEP_PARSER_SST_MM_1(DxUint32_t* msg)
{
     /********* Variables Definitions ************/
     DxUint32_t    SEP_Error = DX_SUCCESS;

    GlobalMemBuff = DX_NULL;
    CurrGlobalMemBuff = DX_NULL;
    TST_Workspace = DX_NULL;

    /* 1. call to DX_SEP_MNG_SSTGetWorkspaceParams*/
    SEP_Error = DX_SEP_MNG_SSTGetWorkspaceParams(&TST_Workspace,
                                                &TST_WorkspaceSizeInBytes);

    if (TST_Workspace == DX_NULL)
     {
        TST_CheckErrorReturn(SEP_Error,"DX_SEP_MNG_SSTGetWorkspaceParams");
        goto End;
     }

    /*2. allocate memory for GlobalMemBuff for all next needed allocation in the test*/
    GlobalMemBuff = DX_VOS_MemMalloc(sizeof(DxUint8_t)*TST_MAX_SEP_WORKSPACE_MEM);

    if (GlobalMemBuff == DX_NULL)
     {
        TST_CheckErrorReturn(1,"DX_VOS_MemMalloc GlobalMemBuff");
        goto End;
     }
    CurrGlobalMemBuff = GlobalMemBuff;

    /*3. allocate buffer from GlobalMemBuff to data struct*/
    if  ((CurrGlobalMemBuff+sizeof(TST_ATP_MMDataOpTestDataStruct))>(GlobalMemBuff+TST_MAX_SEP_WORKSPACE_MEM))
    {
        TST_CheckErrorReturn(1,"TST_ATP_MMDataOpTestData memory allocation");
        goto End;
    }
    else
    {
        TST_ATP_MMDataOpTestData = (TST_ATP_MMDataOpTestDataStruct*)CurrGlobalMemBuff;
        CurrGlobalMemBuff = CurrGlobalMemBuff+sizeof(TST_ATP_MMDataOpTestDataStruct);
    }

    /* 4. extract parameters from the message */
    /******************************************/
    DX_VOS_FastMemCpy(&TST_ATP_MMDataOpTestData[0], 
                      &msg[DX_SEP_HOST_SEP_BASE_MSG_OFFSET],
                      sizeof(TST_ATP_MMDataOpTestDataStruct));

    /*5. call QA SEP function */
    /***************************/
    SEP_Error = SEPQA_SST_MM_1();
    SEP_Error = TST_CheckErrorReturn(SEP_Error,"SEPQA_SST_MM_1");

End:
    /*6. Free allocated buffers */
    DX_VOS_MemFree(GlobalMemBuff);

    /*7. update SEP message with appropriate  op code and updated data struct*/
    msg[DX_SEP_HOST_SEP_PROTOCOL_MSG_OP_CODE_OFFSET] = DX_SEP_HOST_SEP_PROTOCOL_SST_MM_1_OP_CODE;

    DX_VOS_FastMemCpy(&msg[DX_SEP_HOST_SEP_PROTOCOL_MSG_RC_OFFSET + 1],
                      &TST_ATP_MMDataOpTestData[0], 
                      sizeof(TST_ATP_MMDataOpTestDataStruct));

    /*8. end SEP message and return */
    return DX_SEP_EndMessage(msg, SEP_Error, 4);

}
/*****************************************************************************
* Function Name:
*  DX_SEP_PARSER_SST_MM_2
*  
* Inputs:
*  msg - message with all requested parameters.
*
* Outputs: 
*  DxUint32_t - Function error return
*
* Description:
* This function does the parsing for the external application SEPQA_SST_InitTerminate finction.
* It calls the SEP function with parameters parsed from input message
*
* Algorithm: 
* 1. call to DX_SEP_MNG_SSTGetWorkspaceParams
* 2. allocate memory for GlobalMemBuff for all next needed allocation in the test
* 3. allocate buffer from GlobalMemBuff to data struct
* 4. extract parameters from the message 
* 5. call QA SEP function
* 6. free allocated GlobalMemBuff
* 7. end SEP message and return
******************************************************************************/ 
DxUint32_t DX_SEP_PARSER_SST_MM_2(DxUint32_t* msg)
{
     /********* Variables Definitions ************/
     DxUint32_t    SEP_Error = DX_SUCCESS;

    GlobalMemBuff = DX_NULL;
    CurrGlobalMemBuff = DX_NULL;
    TST_Workspace = DX_NULL;

    /* 1. call to DX_SEP_MNG_SSTGetWorkspaceParams*/
    SEP_Error = DX_SEP_MNG_SSTGetWorkspaceParams(&TST_Workspace,
                                                &TST_WorkspaceSizeInBytes);

    if (TST_Workspace == DX_NULL)
     {
        TST_CheckErrorReturn(SEP_Error,"DX_SEP_MNG_SSTGetWorkspaceParams");
        goto End;
     }

    /*2. allocate memory for GlobalMemBuff for all next needed allocation in the test*/
    GlobalMemBuff = DX_VOS_MemMalloc(sizeof(DxUint8_t)*TST_MAX_SEP_WORKSPACE_MEM);

    if (GlobalMemBuff == DX_NULL)
     {
        TST_CheckErrorReturn(1,"DX_VOS_MemMalloc GlobalMemBuff");
        goto End;
     }
    CurrGlobalMemBuff = GlobalMemBuff;

    /*3. allocate buffer from GlobalMemBuff to data struct*/
    if  ((CurrGlobalMemBuff+sizeof(TST_ATP_MMDataOpTestDataStruct))>(GlobalMemBuff+TST_MAX_SEP_WORKSPACE_MEM))
    {
        TST_CheckErrorReturn(1,"TST_ATP_MMDataOpTestData memory allocation");
        goto End;
    }
    else
    {
        TST_ATP_MMDataOpTestData = (TST_ATP_MMDataOpTestDataStruct*)CurrGlobalMemBuff;
        CurrGlobalMemBuff = CurrGlobalMemBuff+sizeof(TST_ATP_MMDataOpTestDataStruct);
    }

    /* 4. extract parameters from the message */
    /******************************************/
    DX_VOS_FastMemCpy(&TST_ATP_MMDataOpTestData[0], 
                      &msg[DX_SEP_HOST_SEP_BASE_MSG_OFFSET],
                      sizeof(TST_ATP_MMDataOpTestDataStruct));


    /*5. call QA SEP function */
    /***************************/
    SEP_Error = SEPQA_SST_MM_2();
    SEP_Error = TST_CheckErrorReturn(SEP_Error,"SEPQA_SST_MM_2");

End:
    /*6. Free allocated buffers */
    DX_VOS_MemFree(GlobalMemBuff);

    /*7. end SEP message and return */
    msg[DX_SEP_HOST_SEP_PROTOCOL_MSG_OP_CODE_OFFSET] = DX_SEP_HOST_SEP_PROTOCOL_SST_MM_2_OP_CODE;
    return DX_SEP_EndMessage(msg, SEP_Error, 4);

}
